diff -Naur -X diff_ignore rsync-3.0.6_base/config.h rsync/config.h
--- rsync-3.0.6_base/config.h	2010-09-16 18:00:06.000000000 -0400
+++ rsync/config.h	2019-01-14 21:18:34.000000000 -0500
@@ -148,10 +148,10 @@
 /* #undef HAVE_HPUX_ACLS */
 
 /* Define to 1 if you have the <iconv.h> header file. */
-#define HAVE_ICONV_H 1
+//#define HAVE_ICONV_H 1
 
 /* Define to 1 if you have the `iconv_open' function. */
-/* #undef HAVE_ICONV_OPEN */
+#define HAVE_ICONV_OPEN 1
 
 /* Define to 1 if the system has the type `id_t'. */
 #define HAVE_ID_T 1
@@ -172,6 +172,7 @@
 #define HAVE_LANGINFO_H 1
 
 /* Define to 1 if you have the `lchmod' function. */
+/* #undef HAVE_LCHMOD */
 #define HAVE_LCHMOD 1
 
 /* Define to 1 if you have the `lchown' function. */
@@ -214,7 +215,7 @@
 /* #undef HAVE_LINUX_XATTRS */
 
 /* Define to 1 if you have the `locale_charset' function. */
-/* #undef HAVE_LOCALE_CHARSET */
+#define HAVE_LOCALE_CHARSET 1
 
 /* Define to 1 if you have the <locale.h> header file. */
 #define HAVE_LOCALE_H 1
@@ -525,7 +526,7 @@
 
 /* Define if you want the --iconv option. Specifing a value will set the
    default iconv setting (a NULL means no --iconv processing by default). */
-/* #undef ICONV_OPTION */
+#define ICONV_OPTION NULL
 
 /* true if you have IPv6 */
 #define INET6 1
@@ -602,7 +603,7 @@
 #define SIZEOF_INT64_T 8
 
 /* The size of `long', as computed by sizeof. */
-#define SIZEOF_LONG 8
+#define SIZEOF_LONG 4
 
 /* The size of `long long', as computed by sizeof. */
 #define SIZEOF_LONG_LONG 8
@@ -617,7 +618,7 @@
 #define SIZEOF_SHORT 2
 
 /* The size of `time_t', as computed by sizeof. */
-#define SIZEOF_TIME_T 8
+#define SIZEOF_TIME_T 4
 
 /* The size of `uint16_t', as computed by sizeof. */
 #define SIZEOF_UINT16_T 2
@@ -646,10 +647,10 @@
 #define TIME_WITH_SYS_TIME 1
 
 /* Define to 1 if you want rsync to make use of iconv_open() */
-/* #undef USE_ICONV_OPEN */
+#define USE_ICONV_OPEN 1
 
 /* String to pass to iconv() for the UTF-8 charset. */
-/* #undef UTF8_CHARSET */
+#define UTF8_CHARSET "UTF-8"
 
 /* Define WORDS_BIGENDIAN to 1 if your processor stores words with the most
    significant byte first (like Motorola and SPARC, unlike Intel). */
@@ -686,3 +687,6 @@
 
 /* Define to `int' if <sys/types.h> doesn't define. */
 /* #undef uid_t */
+
+// BOMBICH
+#define PARSEABLE_OUTPUT 1
diff -Naur -X diff_ignore rsync-3.0.6_base/exclude.c rsync/exclude.c
--- rsync-3.0.6_base/exclude.c	2009-01-17 16:41:35.000000000 -0500
+++ rsync/exclude.c	2014-12-06 21:12:18.000000000 -0500
@@ -36,6 +36,7 @@
 extern int sanitize_paths;
 extern int protocol_version;
 extern int module_id;
+extern int logfile_format_has_i;
 
 extern char curr_dir[];
 extern unsigned int curr_dir_len;
@@ -629,14 +630,18 @@
 	 * then it is stripped out by add_rule().  So as a special
 	 * case we add it back in here. */
 
-	if (verbose >= 2) {
+	if (verbose >= 2 || logfile_format_has_i) {
 		static char *actions[2][2]
 		    = { {"show", "hid"}, {"risk", "protect"} };
 		const char *w = who_am_i();
-		rprintf(code, "[%s] %sing %s %s because of pattern %s%s%s\n",
-		    w, actions[*w!='s'][!(ent->match_flags&MATCHFLG_INCLUDE)],
-		    name_is_dir ? "directory" : "file", name, ent->pattern,
-		    ent->match_flags & MATCHFLG_DIRECTORY ? "/" : "", type);
+		if (logfile_format_has_i) {
+			log_non_transfer(name, name_is_dir ? S_IFDIR : S_IFREG, *w == 's' ? ITEM_EXCLUDED : ITEM_PROTECTED);
+		} else {
+			rprintf(code, "[%s] %sing %s %s because of pattern %s%s%s\n",
+				w, actions[*w!='s'][!(ent->match_flags&MATCHFLG_INCLUDE)],
+				name_is_dir ? "directory" : "file", name, ent->pattern,
+				ent->match_flags & MATCHFLG_DIRECTORY ? "/" : "", type);
+		}
 	}
 }
 
diff -Naur -X diff_ignore rsync-3.0.6_base/fileio.c rsync/fileio.c
--- rsync-3.0.6_base/fileio.c	2009-01-17 16:41:35.000000000 -0500
+++ rsync/fileio.c	2018-09-17 15:35:28.000000000 -0400
@@ -26,6 +26,7 @@
 #endif
 
 extern int sparse_files;
+extern int write_size;
 
 static char last_byte;
 static OFF_T sparse_seek = 0;
@@ -114,12 +115,12 @@
 
 	while (len > 0) {
 		int r1;
-		if (sparse_files > 0) {
+		if ((0) && sparse_files > 0) {
 			int len1 = MIN(len, SPARSE_WRITE_SIZE);
 			r1 = write_sparse(f, buf, len1);
 		} else {
 			if (!wf_writeBuf) {
-				wf_writeBufSize = WRITE_SIZE * 8;
+				wf_writeBufSize = write_size;
 				wf_writeBufCnt  = 0;
 				wf_writeBuf = new_array(char, wf_writeBufSize);
 				if (!wf_writeBuf)
@@ -183,8 +184,9 @@
 	if (len == 0)
 		return NULL;
 	if (len < 0) {
-		rprintf(FERROR, "invalid len passed to map_ptr: %ld\n",
-			(long)len);
+		fprintf(stderr, "rsync: invalid len passed to map_ptr: %ld. File size: %lld, offset: %lld\n", (long)len, map->file_size, offset);
+//		system("/usr/sbin/spindump rsync -file /Library/Logs/DiagnosticReports/rsync_special.txt");
+//		system("/usr/sbin/lsof | /usr/bin/grep rsync > /Library/Logs/DiagnosticReports/rsync.open_files.log");
 		exit_cleanup(RERR_FILEIO);
 	}
 
@@ -244,7 +246,7 @@
 	while (read_size > 0) {
 		nread = read(map->fd, map->p + read_offset, read_size);
 		if (nread <= 0) {
-			if (!map->status)
+			if (map->status == 0)
 				map->status = nread ? errno : ENODATA;
 			/* The best we can do is zero the buffer -- the file
 			 * has changed mid transfer! */
@@ -254,6 +256,8 @@
 		map->p_fd_offset += nread;
 		read_offset += nread;
 		read_size -= nread;
+		if (verbose > 1)
+			fprintf(stderr, "Read %.0f bytes\n", (double)map->p_fd_offset);
 	}
 
 	return map->p;
